use crate::image::Pixel;

#[derive(Debug)]
pub struct IncompleteMappingError {
    pub path: std::path::PathBuf,
    pub missing_colors: Vec<Pixel>,
}

impl std::fmt::Display for IncompleteMappingError {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        writeln!(
            f,
            "`{:?}` is missing entries for the following pixel colors:",
            self.path
        )?;
        for color in self.missing_colors.iter() {
            writeln!(f, "  - {:?}", color)?;
        }
        Ok(())
    }
}

impl std::error::Error for IncompleteMappingError {}
